#include "gtkextext.h"	


#define MAXLEN 4096

/*
    This is the main application data structure.  All susequent
    data structures are linked back into this one.  There should
    be only one instance per application instanace for this 
    struct.
*/
struct cmj
{
	struct		cmj_doc *current;  /* Document Data Structure */
	GtkWidget	*app;		   /* Gnome Application pointer */
	GtkWidget	*notebook;	   /* GTK Notebook GUI Object */
	gint		nb_pages;	   /* Number of pages in the
					      notebook. */	
	gint		untitled;	   /* Number of untitled documents
					      which have been created.
					      This value is never
					      deincrimented. */
	GList		*doc_list;	   /* Linked list of open docs */
};

/*
   This datastructure stores information about any open document.  It
   exists in a one to one relationship with all open documents and is
   stored in the GList (Glib Linked List) doc_list in the cmj struct.
*/
struct cmj_doc
{
	gchar		file_name[255];		/* File Name */
	gchar		class_name[255];        /* Java Class Name */
	gchar		class_path[255];	/* Path to Java Class */
	gchar		display_file_name[255]; /* File Name w/o path */
	gint		disk_copy;		/* Saved=1 or unsaved=0 */
	gint		modified;		/* Changed = 1
						   Unchanged = 0 */
	GList		*undo_list;		/* Linked List of actions */
	GList		*undo_tail;
	GList		*redo_list;		/* Linked List of actions */
	GList		*redo_tail;
	GtkWidget	*doc_label;		/* Label for Doc */
	GtkWidget	*doc_table;		/* GTK GUI Obj to hold GUI
						   Objetcs */
	GtkWidget	*text_box_GTK;		/* GTK Widget instance of
						   text_box */
	GtkExText	*text_box;		/* Main Editor */
	GtkWidget	*v_sbar_tb;		/* Vertical Scrollbar
					 	   for main window */
	GtkWidget	*h_sbar_tb;		/* Horizontal Scrollbar
						   for main window */
	GtkWidget	*jdk_box;		/* JDK Output Window */
	GtkWidget	*v_sbar_jb;		/* Vertical Scrollbar for
						   JDK Window */
	GtkWidget	*file_select;		/* GTK file selection 
						   dialog. */
};

struct undo_entry
{
	char *text;  /* text to work with */
	gint start;  /* starts at pos */
	gint end;    /* ends at pos */
};
