#include "stdio.h"
#include "files.h"

void file_new(GtkWidget *widget, struct cmj *codemonkey)
{
	gchar label[25];

	codemonkey->current = NULL;

	codemonkey->current = (struct cmj_doc *)g_malloc(sizeof(struct cmj_doc));
		if(codemonkey->current == NULL) g_print("Unable to malloc!\n");

	codemonkey->untitled++;
	codemonkey->nb_pages++;

	g_snprintf(label,sizeof(label),"Untitled%d",codemonkey->untitled);
	strcpy(codemonkey->current->file_name, label);

	g_list_append(codemonkey->doc_list, codemonkey->current);

	codemonkey->current->doc_label = gtk_label_new(label);
	codemonkey->current->doc_table = gtk_table_new(3,3,FALSE);
	gtk_notebook_append_page(GTK_NOTEBOOK(codemonkey->notebook),codemonkey->current->doc_table,codemonkey->current->doc_label);
	gtk_widget_set_usize(GTK_WIDGET(codemonkey->notebook), 800,400);

	build_new_editor(codemonkey->current);

	codemonkey->current->jdk_box = gtk_text_new(NULL,NULL);
	gtk_widget_set_usize(GTK_WIDGET(codemonkey->current->text_box), 675, 400);
	gtk_table_attach(GTK_TABLE(codemonkey->current->doc_table),codemonkey->current->text_box_GTK,0,1,0,1,GTK_EXPAND|GTK_FILL,GTK_EXPAND|GTK_FILL,0,0);
/*	
	gtk_text_set_editable(GTK_EXTEXT(codemonkey->current->text_box),TRUE);
*/
	gtk_table_attach(GTK_TABLE(codemonkey->current->doc_table),codemonkey->current->jdk_box,0,1,1,2,GTK_FILL|GTK_EXPAND,GTK_FILL|GTK_EXPAND,0,0);

	gtk_signal_connect(GTK_OBJECT(codemonkey->current->text_box), "changed", GTK_SIGNAL_FUNC(doc_changed), codemonkey);

        init_highlight(GTK_EXTEXT(codemonkey->current->text_box_GTK));

  	gtk_widget_show(codemonkey->current->doc_label);
	gtk_widget_show(codemonkey->current->doc_table);
	gtk_widget_show(codemonkey->current->text_box_GTK);
	gtk_widget_show(codemonkey->current->jdk_box);

	/*
	    Set the current notebook page to the last page in the
	    notebook.  The last page in the notebook is also the
	    new page that was added.  This code will need to be
	    modified if the ability to "insert pages into the 
	    notebook is ever given.
	*/
	gtk_notebook_set_page(GTK_NOTEBOOK(codemonkey->notebook), 
		codemonkey->nb_pages);

	gtk_widget_grab_focus(codemonkey->current->text_box_GTK);

	return;
}

void file_open(GtkWidget *widget, struct cmj *codemonkey)
{
	struct cmj_doc	*doc_ptr;

	doc_ptr = (struct cmj_doc *)g_malloc(sizeof(struct cmj_doc));
		if(doc_ptr == NULL) g_print("Unable to malloc!\n");

	codemonkey->current = doc_ptr;

	g_list_append(codemonkey->doc_list, codemonkey->current);

	codemonkey->current->file_select = gtk_file_selection_new("Open File");

	gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(codemonkey->current->file_select)->cancel_button),"clicked", (GtkSignalFunc)open_dlog_cancel,codemonkey);

	gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(codemonkey->current->file_select)->ok_button), "clicked", (GtkSignalFunc)open_dlog_ok,codemonkey);

	gtk_widget_show(codemonkey->current->file_select);
}

void file_save(GtkWidget *widget, struct cmj *codemonkey)
{
	if(codemonkey->current == NULL)
	{
		return;
	}

	if(codemonkey->current->disk_copy == 0)
	{
		file_save_as(widget,codemonkey);
		return;
	}
	write_file(codemonkey);
}

void file_save_as(GtkWidget *widget, struct cmj *codemonkey)
{
	if(codemonkey->current == NULL)
	{
		return;
	}

	codemonkey->current->file_select = gtk_file_selection_new("Save As...");
	/** to save  **/
	gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(codemonkey->current->file_select)->ok_button),
		"clicked",(GtkSignalFunc)save_as_dlog_ok, codemonkey);

	/** to cancel **/
	gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(codemonkey->current->file_select)->cancel_button),
		"clicked",(GtkSignalFunc)gtk_widget_destroy,GTK_OBJECT(codemonkey->current->file_select));
	gtk_widget_show(codemonkey->current->file_select);
}

void file_close(GtkWidget *widget, struct cmj *codemonkey)
{
	gint current;
	gint nb_current;
	gint dlog_result;	

	if(codemonkey->current == NULL)
	{
		return;
	}

	nb_current = gtk_notebook_get_current_page(GTK_NOTEBOOK(codemonkey->notebook));
	if(nb_current == -1)
	{
		g_print("Failed to get current\n");
		return;
	}
	current = nb_current;
	current++;
	codemonkey->current = (struct cmj_doc *) g_list_nth_data(codemonkey->doc_list, current);
	if(codemonkey->current == NULL)
	{
		g_print("get from list failed\n");
	}
	if(codemonkey->current->modified)
	{
		dlog_result = save_unsaved(codemonkey);
		if(dlog_result == GNOME_DIALOG_YES)
		{
			
		}
		else if(dlog_result == GNOME_DIALOG_NO)
		{
			/* Continue Then */			
		}
		else if(dlog_result == GNOME_DIALOG_CANCEL)
		{
			return;
		}
		else
		{
			g_print("Systems Error: %d\n", dlog_result);
		}
	}

	g_list_remove(codemonkey->doc_list, codemonkey->current);

	gtk_widget_destroy(GTK_WIDGET(codemonkey->current->text_box_GTK));
	gtk_widget_destroy(GTK_WIDGET(codemonkey->current->doc_table));

	gtk_notebook_remove_page(GTK_NOTEBOOK(codemonkey->notebook), nb_current);

	g_free(codemonkey->current);
	codemonkey->current=NULL;

	/*
	   Deincriment our record of the number of pages in the notebook
	   so that we will not reach out of bounds when we try and set
	   the current page to the last page.  Again, if the ability to
	   insert pages into the notebook is ever given this code may
	   need to be revised.
	*/
	codemonkey->nb_pages--;

	/*
	    Set the current notebook page to the last page in the
	    notebook.  The last page in the notebook is also the
	    new page that was added.  This code will need to be
	    modified if the ability to "insert pages into the 
	    notebook is ever given.
	*/
	gtk_notebook_set_page(GTK_NOTEBOOK(codemonkey->notebook), 
		codemonkey->nb_pages);
	nb_current = gtk_notebook_get_current_page(GTK_NOTEBOOK(codemonkey->notebook));
	if(nb_current == -1)
	{
		/* There are no more open notebook pages. */
		return;
	}
	current = nb_current;
	current++;
	codemonkey->current = (struct cmj_doc *) g_list_nth_data(codemonkey->doc_list, current);
	gtk_widget_grab_focus(codemonkey->current->text_box_GTK);
}

void file_close_all(GtkWidget *widget, struct cmj *codemonkey)
{
	codemonkey->current = g_list_nth_data(codemonkey->doc_list, 1);

	while(codemonkey->current != NULL)
	{
		if(codemonkey->current->modified)
		{
			g_print("Unsaved\n");
		}
		gtk_notebook_remove_page(GTK_NOTEBOOK(codemonkey->notebook), 0);
		g_list_remove(codemonkey->doc_list, codemonkey->current);
		g_free(codemonkey->current);
		codemonkey->current = g_list_nth_data(codemonkey->doc_list, 1);
	}

	/*
	   Reset our record of the number of pages in the notebook.
	   Remember, if the ability to insert pages into the notebook
	   is ever given, this code may need to be changed.
	*/
	codemonkey->nb_pages = -1;
}

void file_quit(GtkWidget *widget, struct cmj *codemonkey)
{
	file_close_all(GTK_WIDGET(widget), codemonkey);
	gtk_main_quit();
}

/*********************************** SUPPORT FUNCTIONS ********************************/
void save_as_dlog_ok(GtkWidget *file_dlog, struct cmj *codemonkey)
{
	strcpy(codemonkey->current->file_name, gtk_file_selection_get_filename(GTK_FILE_SELECTION(codemonkey->current->file_select)));
	gtk_label_set(GTK_LABEL(codemonkey->current->doc_label),gtk_file_selection_get_filename(GTK_FILE_SELECTION(codemonkey->current->file_select)));
	write_file(codemonkey);
	strcpy(codemonkey->current->class_name, get_class_name(codemonkey->current->file_name));
	strcpy(codemonkey->current->class_path, get_class_path(codemonkey->current->file_name));	
	gtk_widget_destroy(codemonkey->current->file_select);
}

void open_dlog_cancel(GtkWidget *file_dlog, struct cmj *codemonkey)
{
	gtk_widget_destroy(codemonkey->current->file_select);
	codemonkey->current = NULL;
	return;
}

void open_dlog_ok(GtkWidget *file_dlog, struct cmj *codemonkey)
{
	strcpy(codemonkey->current->file_name, gtk_file_selection_get_filename(GTK_FILE_SELECTION(codemonkey->current->file_select)));
	strcpy(codemonkey->current->display_file_name, get_display_name(codemonkey->current->file_name));
	codemonkey->current->doc_label = gtk_label_new(codemonkey->current->display_file_name);

	codemonkey->current->doc_table = gtk_table_new(3,3,FALSE);
	gtk_notebook_append_page(GTK_NOTEBOOK(codemonkey->notebook),codemonkey->current->doc_table,codemonkey->current->doc_label);
	gtk_widget_set_usize(GTK_WIDGET(codemonkey->notebook), 800,400);

	build_new_editor(codemonkey->current);

	codemonkey->current->jdk_box = gtk_text_new(NULL,NULL);
	gtk_widget_set_usize(GTK_WIDGET(codemonkey->current->text_box), 675, 400);
	gtk_table_attach(GTK_TABLE(codemonkey->current->doc_table),codemonkey->current->text_box_GTK,0,1,0,1,GTK_EXPAND|GTK_FILL,GTK_EXPAND|GTK_FILL,0,0);
	gtk_table_attach(GTK_TABLE(codemonkey->current->doc_table),codemonkey->current->jdk_box,0,1,1,2,GTK_FILL|GTK_EXPAND,GTK_FILL|GTK_EXPAND,0,0);

/*	codemonkey->current->v_sbar_tb = gtk_vscrollbar_new(GTK_TEXT(codemonkey->current->text_box)->vadj);
	gtk_table_attach(GTK_TABLE(codemonkey->current->doc_table),codemonkey->current->v_sbar_tb,1,2,0,1,GTK_FILL,GTK_EXPAND|GTK_FILL|GTK_SHRINK,0,0);
	codemonkey->current->v_sbar_jb = gtk_vscrollbar_new(GTK_TEXT(codemonkey->current->jdk_box)->vadj);
	gtk_table_attach(GTK_TABLE(codemonkey->current->doc_table),codemonkey->current->v_sbar_jb,1,2,1,2,GTK_FILL,GTK_EXPAND|GTK_FILL|GTK_SHRINK,0,0);
*/
	gtk_signal_connect(GTK_OBJECT(codemonkey->current->text_box), "changed", GTK_SIGNAL_FUNC(doc_changed), codemonkey);

	gtk_widget_show(codemonkey->current->doc_label);
	gtk_widget_show(codemonkey->current->doc_table);
	gtk_widget_show(codemonkey->current->text_box_GTK);
/*	gtk_widget_show(codemonkey->current->v_sbar_tb); */
	gtk_widget_show(codemonkey->current->jdk_box);
/*	gtk_widget_show(codemonkey->current->v_sbar_jb); */

	load_file(codemonkey);
	strcpy(codemonkey->current->class_name, get_class_name(codemonkey->current->file_name));
	strcpy(codemonkey->current->class_path, get_class_path(codemonkey->current->file_name));

	gtk_notebook_next_page(GTK_NOTEBOOK(codemonkey->notebook));

	gtk_widget_destroy(codemonkey->current->file_select);

	return;
}

void write_file(struct cmj *codemonkey)
{
	gint txt_end;
	gchar *chars;
	FILE *out_file;

	gtk_extext_freeze(GTK_EXTEXT(codemonkey->current->text_box));

	out_file = fopen(codemonkey->current->file_name, "w");

	if(!out_file)
	{
		g_print("Unable to Open Out File!\n");
		return;
	}

	txt_end = gtk_extext_get_length(GTK_EXTEXT(codemonkey->current->text_box));
	chars = gtk_editable_get_chars(GTK_EDITABLE(codemonkey->current->text_box),0,txt_end);

	fputs(chars,out_file);
	fclose(out_file);
	gtk_extext_thaw(GTK_EXTEXT(codemonkey->current->text_box));
	doc_saved(codemonkey);
	codemonkey->current->modified = 0;
	codemonkey->current->disk_copy = 1;
}

void load_file(struct cmj *codemonkey)
{
	FILE *infile;
	gchar buffer[1024];
	guint nchars;
	guint cur_nchars;
	gint pos;

	infile = fopen(codemonkey->current->file_name, "r");

	gtk_extext_freeze(GTK_EXTEXT(codemonkey->current->text_box));
	cur_nchars=gtk_extext_get_length(GTK_EXTEXT(codemonkey->current->text_box));
	gtk_extext_set_position(GTK_EDITABLE(codemonkey->current->text_box),(guint)0);
	gtk_editable_delete_text(GTK_EDITABLE(codemonkey->current->text_box),
		(guint)0,cur_nchars);
	while(1)
	{
		nchars = fread(buffer, 1, 1024, infile);
		pos=0;
		pos=GTK_EDITABLE(codemonkey->current->text_box)->current_pos;
		gtk_editable_insert_text(GTK_EDITABLE(codemonkey->current->text_box),
			buffer,nchars,&pos);
		if(nchars < 1024)break;
	}
	gtk_extext_thaw(GTK_EXTEXT(codemonkey->current->text_box));

	fclose(infile);

	codemonkey->current->disk_copy=1;
	codemonkey->current->modified=0;
}
