#include <stdio.h>
#include <gtk/gtk.h>
#include <gnome.h>

#include "datastructures.h"

void  set_up_menubar(struct cmj *codemonkey, GtkWidget **menuBar);

extern void file_new(GtkWidget *widget, struct cmj *codemonkey);
extern void file_open(GtkWidget *widget, struct cmj *codemonkey);
extern void file_save(GtkWidget *widget, struct cmj *codemonkey);
extern void file_save_as(GtkWidget *widget, struct cmj *codemonkey);
extern void file_close(GtkWidget *widget, struct cmj *codemonkey);
extern void file_close_all(GtkWidget *widget, struct cmj *codemonkey);
extern void file_quit(GtkWidget *widget, struct cmj *codemonkey);

extern void edit_undo(GtkWidget *widget, struct cmj *codemonkey);
extern void edit_redo(GtkWidget *widget, struct cmj *codemonkey);
extern void edit_undo_all(GtkWidget *widget, struct cmj *codemonkey);
extern void edit_redo_all(GtkWidget *widget, struct cmj *codemonkey);
extern void edit_cut(GtkWidget *widget, struct cmj *codemonkey);
extern void edit_copy(GtkWidget *widget, struct cmj *codemonkey);
extern void edit_paste(GtkWidget *widget, struct cmj *codemonkey);
extern void edit_clear(GtkWidget *widget, struct cmj *codemonkey);
extern void edit_select_all(GtkWidget *widget, struct cmj *codemonkey);

extern void search_find(GtkWidget *widget, struct cmj *codemonkey);
extern void search_find_again(GtkWidget *widget, struct cmj *codemonkey);
extern void search_find_replace(GtkWidget *widget, struct cmj *codemonkey);
extern void search_find_files(GtkWidget *widget, struct cmj *codemonkey);
extern void search_find_replace_files(GtkWidget *widget, struct cmj *codemonkey);

extern void jdk_compile(GtkWidget *widget, struct cmj *codemonkey);
extern void jdk_execute(GtkWidget *widget, struct cmj *codemonkey);
extern void jdk_clear(GtkWidget *widget, struct cmj *codemonkey);

extern void pref_syntax_coloring(GtkWidget *widget, struct cmj *codemonkey);

extern void about(GtkWidget *widget, struct cmj *codemonkey);
extern void dedication(GtkWidget *widget, struct cmj *codemonkey);
extern void nyi(GtkWidget *widget, struct cmj *codemonkey);

static GnomeUIInfo dir_menu[] =
{
	GNOMEUIINFO_END
};

static GnomeUIInfo recent_menu[] =
{
	GNOMEUIINFO_END
};

static GnomeUIInfo file_menu[] =
{
	GNOMEUIINFO_MENU_NEW_ITEM(N_("_New"), N_("Create a new document"),file_new, NULL),
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_MENU_OPEN_ITEM(file_open,NULL),
	{GNOME_APP_UI_SUBTREE, N_("Open _In"), N_("Open In Directory"),&dir_menu,NULL,NULL,GNOME_APP_PIXMAP_STOCK,GNOME_STOCK_MENU_OPEN},
	{GNOME_APP_UI_SUBTREE, N_("Open _Recent"), N_("Open Recent..."),&recent_menu,NULL,NULL,GNOME_APP_PIXMAP_STOCK,GNOME_STOCK_MENU_OPEN},
	GNOMEUIINFO_SEPARATOR,
	{GNOME_APP_UI_ITEM, N_("_Save"), N_("Save the current document"),file_save, NULL,NULL,GNOME_APP_PIXMAP_STOCK,GNOME_STOCK_MENU_SAVE },
	GNOMEUIINFO_MENU_SAVE_AS_ITEM(file_save_as,NULL),
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_MENU_CLOSE_ITEM(file_close,NULL),
	{GNOME_APP_UI_ITEM, N_("Close _All"), N_("Close All Open Files"),file_close_all,NULL,NULL,GNOME_APP_PIXMAP_STOCK,GNOME_STOCK_MENU_CLOSE},
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_MENU_EXIT_ITEM(file_quit,NULL),
	GNOMEUIINFO_END
};

static GnomeUIInfo edit_menu[] =
{
	GNOMEUIINFO_MENU_UNDO_ITEM(edit_undo,NULL),
	GNOMEUIINFO_MENU_REDO_ITEM(edit_redo,NULL),
	{GNOME_APP_UI_ITEM, N_("Undo All"), N_("Undo All"),edit_undo_all,
		NULL,NULL, GNOME_APP_PIXMAP_STOCK,GNOME_STOCK_MENU_UNDO},
	{GNOME_APP_UI_ITEM, N_("Redo All"), N_("Redo All"),edit_redo_all,
		NULL,NULL,GNOME_APP_PIXMAP_STOCK,GNOME_STOCK_MENU_REDO},
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_MENU_CUT_ITEM(edit_cut, NULL),
	GNOMEUIINFO_MENU_COPY_ITEM(edit_copy, NULL),
	GNOMEUIINFO_MENU_PASTE_ITEM(edit_paste, NULL),
	GNOMEUIINFO_MENU_CLEAR_ITEM(edit_clear, NULL),
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_MENU_SELECT_ALL_ITEM(edit_select_all, NULL),
	GNOMEUIINFO_END
};

static GnomeUIInfo search_menu[] =
{
	GNOMEUIINFO_MENU_FIND_ITEM(search_find,NULL),
	GNOMEUIINFO_MENU_FIND_AGAIN_ITEM(search_find_again,NULL),
	GNOMEUIINFO_MENU_REPLACE_ITEM(search_find_replace,NULL),
	GNOMEUIINFO_SEPARATOR,
	{GNOME_APP_UI_ITEM, N_("Find In Files..."), N_("Search files"),search_find_files,NULL,NULL,GNOME_APP_PIXMAP_STOCK,GNOME_STOCK_MENU_SEARCH},
	{GNOME_APP_UI_ITEM, N_("Find Replace In Files..."), N_("Find Replace in Files"),search_find_replace_files,NULL,NULL,GNOME_APP_PIXMAP_STOCK,GNOME_STOCK_MENU_SRCHRPL},
	GNOMEUIINFO_END
};

static GnomeUIInfo jdk_menu[] =
{
	{GNOME_APP_UI_ITEM, N_("_Compile"), N_("Compile current Java program"),  jdk_compile, NULL, NULL, 0, 0, 'a', GDK_CONTROL_MASK},
	{GNOME_APP_UI_ITEM, N_("_Execute"), N_("Execute current Java program"),  jdk_execute, NULL, NULL, 0, 0, 'a', GDK_CONTROL_MASK},
	GNOMEUIINFO_SEPARATOR,
	{GNOME_APP_UI_ITEM, N_("_Clear Output"), N_("Clear JDK Output"),jdk_clear, NULL, NULL, 0, 0, 'a', GDK_CONTROL_MASK},
	GNOMEUIINFO_END
};

static GnomeUIInfo preferences_menu[] =
{
	{GNOME_APP_UI_ITEM, N_("Preferences..."),N_("Set Preferences"),nyi,
		NULL,NULL,GNOME_APP_PIXMAP_STOCK,GNOME_STOCK_MENU_PREF},
	{GNOME_APP_UI_ITEM, N_("Syntax Coloring..."),
		N_("Set Syntax Coloring Preferences"),nyi,NULL,NULL,0,0,
		'a',GDK_CONTROL_MASK},
	GNOMEUIINFO_END
};

static GnomeUIInfo help_menu[] =
{
	GNOMEUIINFO_MENU_ABOUT_ITEM(about,NULL),
	{GNOME_APP_UI_ITEM,N_("Dedication"),N_("Dedication"),dedication,NULL,NULL,
		GNOME_APP_PIXMAP_STOCK,GNOME_STOCK_MENU_ABOUT},
	GNOMEUIINFO_SEPARATOR,
	{GNOME_APP_UI_ITEM,N_("Help System"),N_("CodeMonkey Help System"),
		nyi,NULL,NULL,GNOME_APP_PIXMAP_STOCK,
		GNOME_STOCK_MENU_BLANK},
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_END
};

static GnomeUIInfo main_menu[] =
{
	GNOMEUIINFO_MENU_FILE_TREE(file_menu),
	GNOMEUIINFO_SUBTREE(N_("_Edit"),edit_menu),
	GNOMEUIINFO_SUBTREE(N_("_Search"),search_menu),
	GNOMEUIINFO_SUBTREE(N_("_JDK"),jdk_menu),
	GNOMEUIINFO_SUBTREE(N_("_Preferences"),preferences_menu),
	GNOMEUIINFO_SUBTREE(N_("_Help"),help_menu),
	GNOMEUIINFO_END
};

